<template>
    <div class="personalInfo tabs__Page">

      <LeftBlock class="block">
        <div class="block__title">Deposit money</div>
        <div class="block__titleLine"></div>

        <form style="margin-top: 30px" class="registration__form" @submit.prevent="registration">

          <div class="block__row checkBoxRow">

            <!-- Radio buttons -->
            <div class="checkbox" :class="{'checkbox--error' : $v.user.acceptTC.$error}">
              <input class="checkbox__input" id="deposit1" type="checkbox">
              <label class="checkbox__label" for="deposit1">
              <span class="checkbox__text">
               € 50<a class="link" href="#"></a>
              </span>
              </label>
            </div>

            <div class="checkbox" :class="{'checkbox--error' : $v.user.acceptTC.$error}">
              <input class="checkbox__input" id="deposit2" type="checkbox">
              <label class="checkbox__label" for="deposit2">
              <span class="checkbox__text">
               € 100<a class="link" href="#"></a>
              </span>
              </label>
            </div>

            <div class="checkbox" :class="{'checkbox--error' : $v.user.acceptTC.$error}">
              <input class="checkbox__input" id="deposit3" type="checkbox">
              <label class="checkbox__label" for="deposit3">
              <span class="checkbox__text">
               € 200<a class="link" href="#"></a>
              </span>
              </label>
            </div>

            <div class="checkbox" :class="{'checkbox--error' : $v.user.acceptTC.$error}">
              <input class="checkbox__input" id="deposit4" type="checkbox">
              <label class="checkbox__label" for="deposit4">
              <span class="checkbox__text">
               € 500<a class="link" href="#"></a>
              </span>
              </label>
            </div>

          </div>

          <div data-v-182ac4db="" class="social-auth__footer">
            OR
          </div>

          <div class="block__row nameRow">

            <!-- Amount (€) -->
            <v-input name="Amount (€)"
                     type="text"
                     v-model="user.amount"
                     :isError="$v.user.userName.$error">
            </v-input>
          </div>

          <div class="block__row nameRow">
            <!-- Bonus -->
            <v-input name="Bonus code"
                     type="text"
                     v-model="user.bonus"
                     :isError="$v.user.userName.$error">
              <template slot="error">
                <div class="error" v-if="!$v.user.userName.required">Field is required</div>
                <div class="error" v-else-if="!$v.user.userName.checkUserName">
                  {{$v.user.userName.$params.checkUserName}}
                </div>
              </template>
            </v-input>

          </div>

          <!-- btn -->
          <button class="btn " type="submit" name="Create an account">Continue</button>
        </form>

      </LeftBlock>

      <RightBlock class="block">
        <AccInfo></AccInfo>
      </RightBlock>

    </div>
</template>

<script>
	import LeftBlock from "@/components/Account/LeftBlock";
	import RightBlock from "@/components/Account/RightBlock";
	import AccInfo from "@/components/Account/elements/accountInfo/AccInfo";
	import Input from '@/components/Input';
	import call from '@/services/callService'
	import {helpers, required, sameAs, email, minLength, maxLength} from 'vuelidate/lib/validators';

	const touchMap = new WeakMap();
	// Get Password Policy
	let regExPass = helpers.regex('alpha', /(?=.*\d+)(?=.*[A-Za-z]+).{8,20}/);
	(async () => {
		let result = await call.getPasswordPolicy();
		if (result) {
			(regExPass === helpers.regex('alpha', new RegExp(result.regularExpression))) ? 0 : regExPass = helpers.regex('alpha', new RegExp(result.regularExpression))
		}
	})();

	export default {
		name: "DepositMoney",
		data() {
			return {
				user: {
					amount: '200',
					bonus: 'Aurum 200',
					email: 'test19@test.test',
					password: 'qweqwe123',
					confirmPassword: 'qweqwe123',
					country: '',
					currency: {
						name: undefined
					},
					acceptTC: true
				},
				showPass: false,
				currencies: [],
				activationUrl: 'http://localhost:8080/#/activation&key=',
				date: [1, 2, 3, 4, 5, 6, 7, 8, 9],
				month: [12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1],
				years: [2001, 2000, 1999, 1998, 1997, 1996, 1995, 1994, 1993, 1992, 1991, 1990, 1989, 1988, 1987, 1986]
			}
		},
		validations: {
			user: {
				userName: {
					required,
					async checkUserName(value) {
						try {
							let result = await call.validateUsername(value);
							if (result.isAvailable) {
								return true;
							} else {
								this.$v.user.userName.$params.checkUserName = result.error;
								return false;
							}
						} catch (err) {
							const message = err.desc || JSON.stringify(err);
							throw new Error("EM Username Validations Error:" + message);
						}
					}
				},
				email: {
					required,
					email,
					async checkEmail(value) {
						try {
							let result = await call.validateEmail(value);
							if (result.isAvailable) {
								return true;
							} else {
								this.$v.user.email.$params.checkEmail = result.error;
								return false;
							}
						} catch (err) {
							this.$v.user.email.$params.checkEmail = err.desc || JSON.stringify(err);
							return false;
						}
					}
				},
				password: {
					required,
					minLength: minLength(8),
					maxLength: maxLength(20),
					regExPass
				},
				confirmPassword: {
					sameAsPassword: sameAs('password')
				},
				currency: {
					name: {
						required
					}
				},
				acceptTC: {
					checked: value => value === true
				}
			}
		},
		components: {
			LeftBlock,
			RightBlock,
			'v-input': Input,
			AccInfo
		},
		methods: {
			registration() {
				this.$v.user.userName.$touch();
				this.$v.user.email.$touch();
				this.$v.user.password.$touch();
				this.$v.user.confirmPassword.$touch();
				this.$v.user.currency.$touch();
				this.$v.user.acceptTC.$touch();
				if (this.$v.user.userName.$error || this.$v.user.email.$error || this.$v.user.password.$error || this.$v.user.confirmPassword.$error || this.$v.user.currency.$error) {
					return 0;
				}
				let params = {
					"emailVerificationURL": this.activationUrl,
					"email": this.user.email,
					"password": this.user.password,
					"currency": this.user.currency.code,
					"username": this.user.email,
					"country": this.user.country,
					"userConsents": {
						"termsandconditions": this.user.acceptTC,
						"emailmarketing": false,
						"sms": false,
						"3rdparty": false
					}
				};
				this.accountRegister(params)
					.then((response) => {
						console.log("Регистрация прошла успешно...", response);
					})
					.catch((err) => {
						const message = err.desc || JSON.stringify(err);
						throw new Error("EM REGISRATION Error: " + message);
					});
			},
			async accountRegister(params) {
				return await call.accountRegister(params);
			},
			updateUserName(val) {
				this.delayTouch(this.$v.user.userName);
				this.user.userName = val;
			},
			updateUserEmail(val) {
				this.delayTouch(this.$v.user.email);
				this.user.email = val;
			},
			updateUserPassword(val) {
				this.delayTouch(this.$v.user.password);
				this.user.password = val;
			},
			updateUserConfirmPassword(val) {
				this.delayTouch(this.$v.user.confirmPassword);
				this.user.confirmPassword = val;
			},
			updateCurrency(val) {
				this.user.currency = val;
			},
			async getCurrencies() {
				try {
					let result = await call.getCurrencies();
					if (result) {
						this.currencies = result;
					}
				} catch (err) {
					throw new Error("EM getCurrencies Error:" + err);
				}
			},
			async getCountries() {
				try {
					let result = await call.getCountries();
					if (result) {
						this.user.country = result.currentIPCountry;
					}
				} catch (err) {
					throw new Error("EM getCountries Error:" + err);
				}
			},
			delayTouch($v) {
				$v.$reset();
				if (touchMap.has($v)) {
					clearTimeout(touchMap.get($v));
				}
				touchMap.set($v, setTimeout($v.$touch, 1000));
			}
		},
		computed: {
			typePassword() {
				return (this.showPass) ? 'text' : 'password';
			}
		},
		created() {
			this.getCurrencies();
			this.getCountries();
		}
	}
</script>

<style lang="sass" scoped>

  .checkBoxRow
    justify-content: flex-start

    .checkbox__label
      height: 42px
      width: 90px
      align-items: center
      margin-left: 10px
      &:before
        margin: 0
      &:after
        top: 13px

    .checkbox
      display: flex
      align-items: center
      border: 1px solid #eaeaea
      border-radius: 6px
      margin-right: 20px


      .checkbox__text
        margin: 0 0 0 8px

</style>
